const bsv = require('bsv')
const fetch = require('node-fetch')

async function getB(txid){
    return fetch(`https://bico.media/${txid}.bin`).then(r=>{
        if(r.status != 200)throw new Error(`${r.status}: ${r.statusText}`)
        return r.buffer()
    })
}

async function getC(buffer){
    var md5 = bsv.crypto.Hash.sha256(buffer).toString("hex")
    return fetch(`https://bico.media/${md5}.bin`).then(r=>{
        if(r.status != 200)throw new Error(`${r.status}: ${r.statusText}`)
        return r.buffer()
    })
}

async function getD(address, dKey){
    return fetch(`https://bico.media/${address}/${dKey}`).then(r=>{
        if(r.status != 200)throw new Error(`${r.status}: ${r.statusText}`)
        return r.buffer()
    })
}

module.exports = {
    getB: getB,
    getC: getC,
    getD: getD
}
